<?php

namespace Drupal\migrate_boost;

/**
 * Boost migrations by disabling hooks.
 */
class MigrateBoost {

  /**
   * The alter active.
   */
  protected static bool $boostActive = FALSE;

  /**
   * Disables booster on Drupal and Drupal console boots.
   */
  public static function bootDrupal(): void {
    static::disable();
  }

  /**
   * Enables booster.
   *
   * Resets implementation cache and sets $boostActive class variable.
   */
  public static function enable(): void {
    static::$boostActive = TRUE;
    static::reset();
  }

  /**
   * Disables booster.
   *
   * Resets implementation cache.
   */
  public static function disable(): void {
    static::$boostActive = FALSE;
    static::reset();
  }

  /**
   * Resets implementations cache.
   */
  public static function reset(): void {
    $module_handler = \Drupal::moduleHandler();
    $module_handler->resetImplementations();
  }

  /**
   * Check if boost is active.
   */
  public static function isBoostActive(): bool {
    return static::$boostActive;
  }

}
